'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.secret2id = exports.hash2id = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _history = require('./history');

var _history2 = _interopRequireDefault(_history);

var _swap = require('./swap');

var _swap2 = _interopRequireDefault(_swap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hash2id = exports.hash2id = function hash2id(hash) {
  return new _promise2.default(function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(resolve) {
      var swapHisory;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              swapHisory = _history2.default.getAll();


              swapHisory.forEach(function (swapID) {
                var currentSwap = _swap2.default.get(swapID);
                var flowState = currentSwap.flow.state;
                var currency = currentSwap.flow._flowName.split('2')[0].toLowerCase();
                var currentHash = null;

                switch (currency) {
                  case 'btc':
                    currentHash = flowState.btcScriptCreatingTransactionHash;
                    break;
                  case 'eth':
                    currentHash = flowState.ethSwapCreationTransactionHash;
                    break;
                }

                if (currentHash && currentHash === hash) {
                  resolve(currentSwap.id);
                }
              });
              (0, _debug2.default)('swap.core:simple:swap')('This swap is not found or does not need to be refunded');
              resolve(null);

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var secret2id = exports.secret2id = function secret2id(secret) {
  return new _promise2.default(function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(resolve) {
      var swapHisory;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              swapHisory = _history2.default.getAll();


              swapHisory.forEach(function (swapID) {
                var currentSwap = _swap2.default.get(swapID);
                var currentSecret = currentSwap.flow.state.secret;

                if (currentSecret && currentSecret === secret) {
                  resolve(currentSwap.id);
                }
              });
              (0, _debug2.default)('swap.core:simple:swap')('This swap is not found or does not need to be refunded');
              resolve(null);

            case 4:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }());
};

module.exports = { hash2id: hash2id, secret2id: secret2id };