'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscribe = exports.request = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _swap = require('swap.swap');

var _swap2 = _interopRequireDefault(_swap);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _checkService = require('./checkService');

var _checkService2 = _interopRequireDefault(_checkService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var request = exports.request = function request(order) {
  return new _promise2.default(function (resolve, reject) {
    return order.sendRequest(function (accepted) {
      if (accepted) {
        resolve(order);
      }
    });
  }).then(function (order) {
    (0, _debug2.default)('swap.core:simple:orders')('order accepted', order.id);
    return new _swap2.default(order.id);
  });
};

var subscribe = exports.subscribe = function subscribe(orders, handler) {
  (0, _checkService2.default)(orders, 'orders');

  orders.on('new order', function (order) {
    return handler(order);
  });
  orders.on('new orders', function (orders) {
    return orders.map(handler);
  });
};