'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refund = exports.start = exports.generateSecret = exports.onStep = exports.get = exports.read = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _swap = require('swap.app');

var _swap2 = require('swap.swap');

var _swap3 = _interopRequireDefault(_swap2);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _history = require('./history');

var _history2 = _interopRequireDefault(_history);

var _on = require('./on');

var _on2 = _interopRequireDefault(_on);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var read = exports.read = _swap3.default.read;

var get = exports.get = function get(app, id) {
  return new _swap3.default(id, app);
};

var onStep = exports.onStep = function onStep(swap, _step) {
  return new _promise2.default(function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(resolve) {
      var enterStep;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (_step <= swap.flow.state.step) resolve(swap.flow.state.step);

              (0, _debug2.default)('swap.core:simple:swap')('begin waiting step =', _step, 'on', swap.id);

              enterStep = function enterStep(step) {
                (0, _debug2.default)('swap.core:simple:swap')('waiting for', _step, 'now on', step);

                if (step === _step) {
                  resolve(step);

                  swap.off('enter step', enterStep);
                }
              };

              swap.on('enter step', enterStep);

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var generateSecret = exports.generateSecret = function generateSecret() {
  return _crypto2.default.randomBytes(32).toString('hex');
};

var start = exports.start = function start(swap) {
  return new _promise2.default(function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(resolve) {
      var secret;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = swap.flow._flowName;
              _context2.next = _context2.t0 === "BTC2ETH" ? 3 : _context2.t0 === "ETH2BTC" ? 8 : 15;
              break;

            case 3:
              _context2.next = 5;
              return onStep(swap, 2);

            case 5:
              secret = generateSecret();

              swap.flow.submitSecret(secret);

              return _context2.abrupt('break', 15);

            case 8:
              _context2.next = 10;
              return onStep(swap, 1);

            case 10:
              swap.flow.sign();

              _context2.next = 13;
              return onStep(swap, 3);

            case 13:
              swap.flow.verifyBtcScript();
              return _context2.abrupt('break', 15);

            case 15:
              resolve();

            case 16:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }());
};

var refund = exports.refund = function refund(app, swapID) {
  return new _promise2.default(function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(resolve) {
      var swap;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              (0, _debug2.default)('swap.core:simple:swap')('Swap id =', swapID);
              swap = get(app, swapID);

              if (!swap.flow.state.isRefunded) {
                _context3.next = 7;
                break;
              }

              (0, _debug2.default)('swap.core:simple:swap')('This swap is refunded');
              resolve(true);
              _context3.next = 19;
              break;

            case 7:
              (0, _debug2.default)('swap.core:simple:swap')('Refunding...');

              _context3.prev = 8;
              _context3.next = 11;
              return swap.flow.tryRefund();

            case 11:
              _context3.next = 17;
              break;

            case 13:
              _context3.prev = 13;
              _context3.t0 = _context3['catch'](8);

              (0, _debug2.default)('swap.core:simple:swap')('Can not refund this swap. Try it later');
              swap.flow.state.isRefunded = false;

            case 17:

              if (swap.flow.state.isRefunded) {
                (0, _debug2.default)('swap.core:simple:swap')('This swap is refunded');
                resolve(true);
              }
              resolve(false);

            case 19:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined, [[8, 13]]);
    }));

    return function (_x3) {
      return _ref3.apply(this, arguments);
    };
  }());
};