'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var bitcoin = require('bitcoinjs-lib');
//const request = require('request-promise-native')
var request = require('../helpers/request');
var BigNumber = require('bignumber.js');
var debug = require('debug');

var BITPAY = 'http://localhost:32250/btc/testnet';
var BITPAY_MAIN = 'https://insight.bitpay.com/api';

var BLOCKCYPHER_API = 'https://api.blockcypher.com/v1/btc/main/';
var BLOCKCYPHER_API_TESTNET = 'https://api.blockcypher.com/v1/btc/test3/';
var EARN_COM = 'https://bitcoinfees.earn.com/api/v1/fees/recommended';
// const BLOCKCYPHER_API_TOKEN = process.env.BLOCKCYPHER_API_TOKEN


var filterError = function filterError(error) {
  var name = error.name,
      code = error.code,
      statusCode = error.statusCode,
      options = error.options;


  if (name == 'StatusCodeError' && statusCode == 525) debug('swap.core:bitcoin')('Error:', 'BITPAY refuse:', options.method, options.uri);else debug('swap.core:bitcoin')('UnknownError: statusCode=' + statusCode + ' ' + error.message);

  throw error;
};

var Bitcoin = function () {
  function Bitcoin(_network) {
    var _this = this;

    (0, _classCallCheck3.default)(this, Bitcoin);

    this.checkWithdraw = function (scriptAddress) {
      var url = '/txs/?address=' + scriptAddress;

      return request.get('' + _this.root + url).then(function (json) {
        return JSON.parse(json);
      }).then(function (res) {
        if (res.txs.length > 1 && res.txs[0].vout.length) {
          var address = res.txs[0].vout[0].scriptPubKey.addresses[0];
          var _res$txs$ = res.txs[0],
              txid = _res$txs$.txid,
              amount = _res$txs$.valueOut;

          return {
            address: address,
            txid: txid,
            amount: amount
          };
        }
        return false;
      });
    };

    this.core = bitcoin;

    this.net = bitcoin.networks[_network === 'mainnet' ? 'bitcoin' : 'testnet'];
    this.network = _network;
    this.root = this.network === 'testnet' ? BITPAY : BITPAY_MAIN;
  }

  (0, _createClass3.default)(Bitcoin, [{
    key: 'getRate',
    value: function getRate() {
      // 10 min cache
      request.get('https://noxonfund.com/curs.php', { cacheResponse: 10 * 60 * 1000 }).then(function (_ref) {
        var price_btc = _ref.price_btc;

        return price_btc;
      }).catch(function (err) {
        return console.error('NOXONFUND error: ' + err.message);
      });
    }
  }, {
    key: 'calculateTxSize',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            speed = _ref3.speed,
            unspents = _ref3.unspents,
            address = _ref3.address,
            _ref3$txOut = _ref3.txOut,
            txOut = _ref3$txOut === undefined ? 2 : _ref3$txOut;

        var txIn, txSize;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = unspents;

                if (_context.t0) {
                  _context.next = 5;
                  break;
                }

                _context.next = 4;
                return this.fetchUnspents(address);

              case 4:
                _context.t0 = _context.sent;

              case 5:
                unspents = _context.t0;
                txIn = unspents.length;
                txSize = txIn > 0 ? txIn * 146 + txOut * 33 + (15 + txIn - txOut) : 226; // default tx size for 1 txIn and 2 txOut

                return _context.abrupt('return', txSize);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function calculateTxSize() {
        return _ref2.apply(this, arguments);
      }

      return calculateTxSize;
    }()
  }, {
    key: 'estimateFeeValue',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            feeRate = _ref5.feeRate,
            inSatoshis = _ref5.inSatoshis,
            speed = _ref5.speed,
            address = _ref5.address,
            txSize = _ref5.txSize;

        var DUST, calculatedFeeValue, finalFeeValue;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                DUST = 546;
                calculatedFeeValue = void 0;

                if (!(!txSize && !address)) {
                  _context2.next = 7;
                  break;
                }

                debug('swap.core:bitcoin')('estimateFeeValue: need address or txSize');
                calculatedFeeValue = BigNumber(DUST).multipliedBy(1e-8);
                _context2.next = 20;
                break;

              case 7:
                _context2.t0 = txSize;

                if (_context2.t0) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 11;
                return this.calculateTxSize({ address: address, speed: speed });

              case 11:
                _context2.t0 = _context2.sent;

              case 12:
                txSize = _context2.t0;
                _context2.t1 = feeRate;

                if (_context2.t1) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 17;
                return this.estimateFeeRate({ speed: speed });

              case 17:
                _context2.t1 = _context2.sent;

              case 18:
                feeRate = _context2.t1;


                calculatedFeeValue = BigNumber.maximum(DUST, BigNumber(feeRate).multipliedBy(txSize).div(1024).dp(0, BigNumber.ROUND_HALF_EVEN));

              case 20:
                finalFeeValue = inSatoshis ? calculatedFeeValue.toString() : calculatedFeeValue.multipliedBy(1e-8).toString();
                return _context2.abrupt('return', finalFeeValue);

              case 22:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function estimateFeeValue() {
        return _ref4.apply(this, arguments);
      }

      return estimateFeeValue;
    }()
  }, {
    key: 'estimateFeeRate',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(options) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _context3.next = 3;
                return this.estimateFeeRateBLOCKCYPHER(options);

              case 3:
                return _context3.abrupt('return', _context3.sent);

              case 6:
                _context3.prev = 6;
                _context3.t0 = _context3['catch'](0);

                console.error('EstimateFeeError: BLOCKCYPHER_API ' + _context3.t0.message + ', trying EARN.COM...');
                _context3.next = 11;
                return this.estimateFeeRateEARNCOM(options);

              case 11:
                return _context3.abrupt('return', _context3.sent);

              case 12:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 6]]);
      }));

      function estimateFeeRate(_x3) {
        return _ref6.apply(this, arguments);
      }

      return estimateFeeRate;
    }()
  }, {
    key: 'estimateFeeRateEARNCOM',
    value: function estimateFeeRateEARNCOM() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref7$speed = _ref7.speed,
          speed = _ref7$speed === undefined ? 'fast' : _ref7$speed;

      var _speed = function () {
        switch (speed) {
          case 'fast':
            return 'fastestFee';
          case 'normal':
            return 'halfHourFee';
          case 'slow':
            return 'hourFee';
          default:
            return 'halfHourFee';
        }
      }();

      // 10 minuts cache
      // query request
      // use cache if fail
      return request.get('' + EARN_COM, {
        cacheResponse: 10 * 60 * 1000,
        queryResponse: true,
        cacheOnFail: true
      }).then(function (json) {
        return JSON.parse(json);
      }).then(function (fees) {
        return Number(fees[_speed]) * 1024;
      }).catch(function (error) {
        return filterError(error);
      });
    }
  }, {
    key: 'estimateFeeRateBLOCKCYPHER',
    value: function estimateFeeRateBLOCKCYPHER() {
      var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref8$speed = _ref8.speed,
          speed = _ref8$speed === undefined ? 'fast' : _ref8$speed;

      var _speed = function () {
        switch (speed) {
          case 'fast':
            return 'high_fee_per_kb';
          case 'normal':
            return 'medium_fee_per_kb';
          case 'slow':
            return 'low_fee_per_kb';
          default:
            return 'medium_fee_per_kb';
        }
      }();

      var API_ROOT = this.network === 'testnet' ? BLOCKCYPHER_API_TESTNET : BLOCKCYPHER_API;

      // 10 minuts cache
      // query request
      return request.get('' + API_ROOT, {
        cacheResponse: 10 * 60 * 1000,
        queryResponse: true,
        cacheOnFail: true
      }).then(function (json) {
        return JSON.parse(json);
      }).then(function (info) {
        return Number(info[_speed]);
      }).catch(function (error) {
        return filterError(error);
      });
    }
  }, {
    key: 'fetchBalance',
    value: function fetchBalance(address) {
      // 10 seconds cache
      // query requests
      return request.get(this.root + '/addr/' + address, {
        cacheResponse: 10 * 1000,
        queryResponse: true
      }).then(function (json) {
        var balance = JSON.parse(json).balance;
        debug('swap.core:bitcoin')('BTC Balance:', balance);

        return balance;
      }).catch(function (error) {
        return filterError(error);
      });
    }
  }, {
    key: 'fetchUnspents',
    value: function fetchUnspents(address) {
      // 10 seconds cache
      // query requests
      return request.get(this.root + '/addr/' + address + '/utxo', {
        cacheResponse: 10 * 1000,
        queryResponse: true
      }).then(function (json) {
        return JSON.parse(json);
      }).catch(function (error) {
        return filterError(error);
      });
    }
  }, {
    key: 'broadcastTx',
    value: function broadcastTx(txRaw) {
      return request.post(this.root + '/tx/send', {
        json: true,
        body: {
          rawtx: txRaw
        }
      }).catch(function (error) {
        return filterError(error);
      });
    }
  }, {
    key: 'fetchTx',
    value: function fetchTx(hash) {
      // 10 seconds cache
      // query request
      return request.get(this.root + '/tx/' + hash, {
        cacheResponse: 10 * 1000,
        queryResponse: true
      }).then(function (json) {
        return JSON.parse(json);
      }).then(function (_ref9) {
        var fees = _ref9.fees,
            rest = (0, _objectWithoutProperties3.default)(_ref9, ['fees']);
        return (0, _extends3.default)({
          fees: BigNumber(fees).multipliedBy(1e8)
        }, rest);
      }).catch(function (error) {
        debug('swap.core:bitcoin')('BitPay:', error);
        return {};
      });
    }
  }, {
    key: 'fetchTxInfo',
    value: function fetchTxInfo(hash) {
      return this.fetchTx(hash).then(function (_ref10) {
        var vin = _ref10.vin,
            rest = (0, _objectWithoutProperties3.default)(_ref10, ['vin']);
        return (0, _extends3.default)({
          senderAddress: vin[0].addr
        }, rest);
      }).catch(function (error) {
        return error;
      });
    }
  }, {
    key: 'fetchOmniBalance',
    value: function fetchOmniBalance(address) {
      var assetId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 31;

      return request.post('https://api.omniexplorer.info/v1/address/addr/', {
        json: true,
        form: {
          addr: address
        },
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        }
      }).then(function (response) {
        var error = response.error,
            balance = response.balance;


        if (error) throw new Error('Omni Balance: ' + error);

        var findById = balance.filter(function (asset) {
          return parseInt(asset.id) === assetId || asset.id === assetId;
        });

        if (!findById.length) {
          return 0;
        }

        debug('swap.core:bitcoin')('Omni Balance:', findById[0].value);
        debug('swap.core:bitcoin')('Omni Balance pending:', findById[0].pendingpos);
        debug('swap.core:bitcoin')('Omni Balance pending:', findById[0].pendingneg);

        var usdsatoshis = BigNumber(findById[0].value);

        if (usdsatoshis) {
          return usdsatoshis.dividedBy(1e8).toNumber();
        } else {
          return 0;
        }
      }).catch(function (error) {
        return filterError(error);
      });
    }

    /*
      Проверяет списание со скрипта - последняя транзакция выхода
      Возвращает txId, адресс и сумму
    */

  }, {
    key: 'sendTransaction',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref12, handleTransactionHash) {
        var account = _ref12.account,
            to = _ref12.to,
            value = _ref12.value;
        var tx, unspents, fundValue, feeValue, totalUnspent, skipValue, txRaw, result;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                tx = new bitcoin.TransactionBuilder(this.net);


                value = BigNumber(value);

                _context4.next = 4;
                return this.fetchUnspents(account.getAddress());

              case 4:
                unspents = _context4.sent;
                fundValue = value.multipliedBy(1e8).integerValue().toNumber();
                feeValue = 1000;
                totalUnspent = unspents.reduce(function (summ, _ref13) {
                  var satoshis = _ref13.satoshis;
                  return summ + satoshis;
                }, 0);
                skipValue = totalUnspent - fundValue - feeValue;

                if (!(totalUnspent < feeValue + fundValue)) {
                  _context4.next = 11;
                  break;
                }

                throw new Error('Total less than fee: ' + totalUnspent + ' < ' + feeValue + ' + ' + fundValue);

              case 11:

                unspents.forEach(function (_ref14) {
                  var txid = _ref14.txid,
                      vout = _ref14.vout;
                  return tx.addInput(txid, vout, 0xfffffffe);
                });
                tx.addOutput(to, fundValue);

                if (skipValue) tx.addOutput(account.getAddress(), skipValue);

                tx.inputs.forEach(function (input, index) {
                  tx.sign(index, account);
                });

                txRaw = tx.buildIncomplete();


                if (typeof handleTransactionHash === 'function') {
                  handleTransactionHash(txRaw.getId());
                  debug('swap.core:bitcoin')('tx id', txRaw.getId());
                }

                debug('swap.core:bitcoin')('raw tx = ', txRaw.toHex());

                _context4.next = 20;
                return this.broadcastTx(txRaw.toHex());

              case 20:
                result = _context4.sent;
                return _context4.abrupt('return', result);

              case 22:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function sendTransaction(_x7, _x8) {
        return _ref11.apply(this, arguments);
      }

      return sendTransaction;
    }()
  }]);
  return Bitcoin;
}();

module.exports = new Bitcoin();
module.exports.mainnet = function () {
  return new Bitcoin('mainnet');
};
module.exports.testnet = function () {
  return new Bitcoin('testnet');
};