'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _swap = require('swap.app');

var _swap2 = _interopRequireDefault(_swap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Wallet = require('./wallet');

var configFactory = require('./config');

var network = process.env.NETWORK;

module.exports = function (settings) {

  var getConfig = configFactory[network || 'testnet'];

  var config = getConfig((0, _extends3.default)({ contracts: {} }, settings));

  var swapApp = _swap2.default.init(config);

  var wallet = new Wallet(swapApp, _swap.constants, config);

  var _swapApp$services = swapApp.services,
      auth = _swapApp$services.auth,
      room = _swapApp$services.room,
      orders = _swapApp$services.orders;


  var app = {
    app: swapApp,
    wallet: wallet,
    auth: auth,
    room: room,
    orders: orders
  };

  return app;
};