'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../instances'),
    bitcoin = _require.bitcoin,
    ethereum = _require.ethereum;

var debug = require('debug')('swap.core:simple:wallet');

var BLOCKCHAININFO = function BLOCKCHAININFO(isMain) {
  return isMain ? 'https://blockchain.info' : 'https://testnet.blockchain.info';
};
var ETHERSCANIO = function ETHERSCANIO(isMain) {
  return isMain ? 'https://etherscan.io' : 'https://rinkeby.etherscan.io';
};

var Wallet = function () {
  function Wallet(app, constants, config) {
    (0, _classCallCheck3.default)(this, Wallet);

    this.id = config.id;
    this.network = app.network;
    this.ethereum = ethereum;
    this.bitcoin = bitcoin;
    this.swapApp = app;
    this.constants = constants;
    this.auth = app.services.auth;
    this.balances = {};
  }

  (0, _createClass3.default)(Wallet, [{
    key: 'withdraw',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(from, to, value) {
        var account;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = from;
                _context.next = _context.t0 === 'btc' ? 3 : _context.t0 === 'eth' ? 7 : 10;
                break;

              case 3:
                account = this.auth.accounts.btc;
                _context.next = 6;
                return this.bitcoin.sendTransaction({ account: account, to: to, value: value });

              case 6:
                return _context.abrupt('return', _context.sent);

              case 7:
                _context.next = 9;
                return this.ethereum.sendTransaction({ to: to, value: value });

              case 9:
                return _context.abrupt('return', _context.sent);

              case 10:
                return _context.abrupt('return', _promise2.default.reject('not implemented'));

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function withdraw(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return withdraw;
    }()
  }, {
    key: 'getBalanceBySymbol',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(symbol) {
        var _this = this;

        var balances;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this.balances[symbol]) {
                  _context2.next = 6;
                  break;
                }

                debug('updating balance', Date());
                _context2.next = 4;
                return this.getBalance();

              case 4:
                balances = _context2.sent;

                balances.map(function (x) {
                  return _this.balances[x.symbol] = x;
                });

              case 6:
                return _context2.abrupt('return', this.balances[symbol]);

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getBalanceBySymbol(_x4) {
        return _ref2.apply(this, arguments);
      }

      return getBalanceBySymbol;
    }()
  }, {
    key: 'getData',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var _this2 = this;

        var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            coins = _ref4.coins;

        var currencies, data, addresses, fetchBalances, values;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                currencies = coins || (0, _values2.default)(this.constants.COINS);
                data = this.auth.getPublicData();
                addresses = currencies.reduce(function (obj, symbol) {
                  var _ref5 = symbol == 'BTC' /*|| symbol == 'USDT' */ ? data.btc : data.eth,
                      address = _ref5.address;

                  return (0, _extends4.default)({}, obj, (0, _defineProperty3.default)({}, symbol, address));
                }, {});
                fetchBalances = currencies.map(function (symbol) {
                  try {
                    var instance = _this2.swapApp.swaps[symbol];
                    var address = addresses[symbol];

                    return instance ? instance.fetchBalance(address) : '-';
                  } catch (err) {
                    debug('Error fetching ' + symbol + ' balance: ' + err.message);
                    return '-';
                  }
                });
                _context3.next = 6;
                return _promise2.default.all(fetchBalances);

              case 6:
                values = _context3.sent;
                return _context3.abrupt('return', values.map(function (value, index) {
                  return {
                    symbol: currencies[index],
                    amount: value,
                    address: addresses[currencies[index]]
                  };
                }));

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getData() {
        return _ref3.apply(this, arguments);
      }

      return getData;
    }()
  }, {
    key: 'fetchBalance',
    value: function fetchBalance(symbol) {
      var data = this.auth.getPublicData();
      var account = symbol == 'BTC' /*|| symbol == 'USDT' */ ? data.btc : data.eth;
      var instance = this.swapApp.swaps[symbol];

      return instance ? instance.fetchBalance(account.address) : '-';
    }
  }, {
    key: 'getBalance',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(symbols) {
        var _this3 = this;

        var currencies, values;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                currencies = symbols || (0, _values2.default)(this.constants.COINS);
                _context4.next = 3;
                return _promise2.default.all(currencies.map(function (symbol) {
                  return _this3.fetchBalance(symbol);
                }));

              case 3:
                values = _context4.sent;
                return _context4.abrupt('return', values.map(function (value, index) {
                  return {
                    symbol: currencies[index],
                    value: value
                  };
                }));

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getBalance(_x6) {
        return _ref6.apply(this, arguments);
      }

      return getBalance;
    }()
  }, {
    key: 'getCore',
    value: function getCore() {
      return {
        eth: this.ethereum.core,
        btc: this.bitcoin.core
      };
    }
  }, {
    key: 'view',
    value: function view() {
      return (0, _extends4.default)({
        id: this.id,
        network: this.network,
        mainnet: this.swapApp.isMainNet(),
        'etherscan.io': ETHERSCANIO(this.swapApp.isMainNet()) + '/address/' + this.auth.accounts.eth.address,
        'blockchain.info': BLOCKCHAININFO(this.swapApp.isMainNet()) + '/address/' + this.auth.accounts.btc.getAddress(),
        room: this.swapApp.services.room.roomName
      }, this.auth.getPublicData());
    }
  }, {
    key: 'detailedView',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var gasPrice, gasLimit, btcFee;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.ethereum.core.eth.getGasPrice();

              case 2:
                gasPrice = _context5.sent;
                gasLimit = 3e6; // TODO sync with EthSwap.js

                btcFee = 15000; // TODO sync with BtcSwap.js and bitcoin instance

                return _context5.abrupt('return', {
                  eth: {
                    gasPrice: gasPrice,
                    gasLimit: gasLimit
                    // ...ethereum.core,
                  },
                  btc: {
                    fee: btcFee
                    // ...bitcoin.core,
                  },
                  wallet: this.view()
                });

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function detailedView() {
        return _ref7.apply(this, arguments);
      }

      return detailedView;
    }()
  }]);
  return Wallet;
}();

module.exports = Wallet;